> ## Documentation Index
> Fetch the complete documentation index at: https://ona.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Get Membership

> Gets a specific membership by group ID and subject.

`Unary` · [`Groups`](https://ona.com/docs/api-reference/generated/group/overview)

Gets a specific membership by group ID and subject.

Use this method to:

* Check if a user or service account is a member of a group
* Verify group membership for access control

### Examples

* Check user membership:

  Checks if a user is a member of a specific group.

  ```yaml theme={null}
  groupId: "d2c94c27-3b76-4a42-b88c-95a85e392c68"
  subject:
    id: "f53d2330-3795-4c5d-a1f3-453121af9c60"
    principal: PRINCIPAL_USER
  ```

### Authorization

All organization members can check group membership (transparency model).

## Endpoint

```text theme={null}
POST /api/gitpod.v1.GroupService/GetMembership
```

Send a Bearer token as described in [Authentication](https://ona.com/docs/api-reference.md#authenticate-requests). If your organization uses a custom management-plane domain, replace `https://app.ona.com` with that domain.

## Request example

```bash cURL theme={null}
export ONA_HOST=https://app.ona.com
export ONA_API_KEY=<your-token>

curl --request POST \
  --url "$ONA_HOST/api/gitpod.v1.GroupService/GetMembership" \
  --header "Authorization: Bearer $ONA_API_KEY" \
  --header "Content-Type: application/json" \
  --data '{
  "subject": {
    "id": "<id>"
  }
}'
```

```python Python theme={null}
import gitpod.v1.group_pb2 as group_pb2
import gitpod.v1.identity_pb2 as identity_pb2
from ona_sdk import create_client_from_env

ona = create_client_from_env()
request = group_pb2.GetMembershipRequest(
    subject=identity_pb2.Subject(
        id="<id>",
    ),
)
response = ona.services.group.get_membership(request)
print(response)
```

```typescript TypeScript theme={null}
import { create } from "@bufbuild/protobuf";
import { createClientFromEnv } from "@gitpod/sdk";
import { GetMembershipRequestSchema } from "@gitpod/sdk/gitpod/v1/group_pb";

async function main() {
  const ona = createClientFromEnv();
  const request = create(GetMembershipRequestSchema, {
    subject: {
      id: "<id>",
    },
  });
  const response = await ona.services.group.getMembership(request);
  console.log(response);
}

main().catch(console.error);
```

```go Go theme={null}
package main

import (
	"context"
	"fmt"
	"log"

	"connectrpc.com/connect"
	"github.com/gitpod-io/gitpod-sdk-go/sdk"
	gitpodpb "github.com/gitpod-io/gitpod-sdk-go/v1"
)

func main() {
	ona, err := sdk.NewFromEnv()
	if err != nil {
		log.Fatal(err)
	}

	request := connect.NewRequest(&gitpodpb.GetMembershipRequest{
		Subject: &gitpodpb.Subject{
			Id: "<id>",
		},
	})
	response, err := ona.Services.Group.GetMembership(context.Background(), request)
	if err != nil {
		log.Fatal(err)
	}
	fmt.Println(response.Msg)
}
```

```json Request body theme={null}
{
  "subject": {
    "id": "<id>"
  }
}
```

## Request

`gitpod.v1.GetMembershipRequest`

GetMembership messages

| Field | Type | Required | Description |
| - | - | - | - |
| `groupId` | string | No | Constraints: `string.uuid=true`. |
| `subject` | [Subject](#type-gitpod-v1-subject) | Yes | Subject to check membership for Constraints: `required=true`. |

## Response

`gitpod.v1.GetMembershipResponse`

| Field | Type | Required | Description |
| - | - | - | - |
| `member` | [GroupMembership](#type-gitpod-v1-group-membership) | No | The membership if found, nil if subject is not a member |

## Related types

> [accordion] GroupMembership
>
> GroupMembership represents a subject's membership in a group
>
> `gitpod.v1.GroupMembership`
>
> | Field | Type | Required | Description |
> | - | - | - | - |
> | `id` | string | No | Unique identifier for the group membership Constraints: `string.uuid=true`. |
> | `subject` | [Subject](#type-gitpod-v1-subject) | No | Subject (user, runner, environment, service account, etc.) |
> | `groupId` | string | No | Group identifier Constraints: `string.uuid=true`. |
> | `name` | string | No | Subject's display name |
> | `avatarUrl` | string | No | Subject's avatar URL |

> [accordion] Subject
>
> `gitpod.v1.Subject`
>
> | Field | Type | Required | Description |
> | - | - | - | - |
> | `id` | string | No | id is the UUID of the subject Constraints: `ignore=1, string.uuid=true`. |
> | `principal` | [Principal](#enum-gitpod-v1-principal) | No | Principal is the principal of the subject Constraints: `enum.defined_only=true`. |

> [accordion] Principal
>
> | Value | Number | Description |
> | - | -: | - |
> | `PRINCIPAL_UNSPECIFIED` | 0 | |
> | `PRINCIPAL_ACCOUNT` | 1 | |
> | `PRINCIPAL_USER` | 2 | |
> | `PRINCIPAL_RUNNER` | 3 | |
> | `PRINCIPAL_ENVIRONMENT` | 4 | |
> | `PRINCIPAL_SERVICE_ACCOUNT` | 5 | |
> | `PRINCIPAL_RUNNER_MANAGER` | 6 | |


This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.